#include<stdio.h>
long long int resi(int poc, int kraj, int k, long long int a[])
{
	if(k==0)
	{
		long long int sum=0,i;
		for(i=poc;i<kraj;i++)
		sum+=a[i] %(1000000000+7);
		
		return sum;
	}
	
	long long int sum=0,i,j;
	for(i=poc;i<kraj;i++)
	for(j=i+1;j<=kraj;j++)
	{
		sum+=resi(i,j,k-1,a)%(1000000000+7);
	}
	
	return sum;
}
main()
{
	int k,n,i;
	long long int a[2000000];
	scanf("%d%d",&n,&k);
	
	for(i=0;i<n;i++)
	scanf("%lld",&a[i]);
	
	printf("%lld",resi(0,n,k,a));
}